<?php
/*
Simple:Press
Polls Plugin Admin Options Form
$LastChangedDate: 2014-09-14 17:26:23 -0700 (Sun, 14 Sep 2014) $
$Rev: 11973 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_polls_admin_manage_form() {
    global $wpdb;

    if (!sp_current_user_can('SPF Manage Polls')) {
    	spa_etext('Access denied - you do not have permission');
    	die();
    }

	spa_paint_options_init();
	spa_paint_open_tab(__('Polls', 'sp-polls').' - '.__('Poll Stats', 'sp-polls'), true);
    	spa_paint_open_panel();
    		spa_paint_open_fieldset(__('Stats', 'sp-polls'), false);
            	$stats = spdb_select('row', 'SELECT COUNT(*) AS count, COUNT(IF(poll_active = "1", 1, 0)) AS active, SUM(poll_votes) as votes, SUM(poll_voters) as voters FROM '.SPPOLLS);
?>
                <table class="widefat">
                    <tr>
                        <td><b><?php echo __('Number of polls', 'sp-polls'); ?>:</b></td>
                        <td><?php echo $stats->count; ?></td>
                    </tr>
                    <tr class="alternate">
                        <td><b><?php echo __('Number of active of polls', 'sp-polls'); ?>:</b></td>
                        <td><?php echo $stats->active ?></td>
                    </tr>
                    <tr>
                        <td><b><?php echo __('Number votes cast', 'sp-polls'); ?>:</b></td>
                        <td><?php echo $stats->votes; ?></td>
                    </tr>
                    <tr class="alternate">
                        <td><b><?php echo __('Number of voters', 'sp-polls'); ?>:</b></td>
                        <td><?php echo $stats->voters ?></td>
                    </tr>
                </table>
<?php
    		spa_paint_close_fieldset();
    	spa_paint_close_panel();

    	spa_paint_open_panel();
    		spa_paint_open_fieldset(__('Polls', 'sp-polls'), true, 'polls-manage');
    			$paged = (isset($_GET['paged'])) ? sp_esc_int($_GET['paged']) : 1;
    			$polls_per_page = (isset($_GET['polls_per_page'])) ? sp_esc_int($_GET['polls_per_page']) : 10;
				$search = (isset($_GET['s'])) ? sp_esc_str($_GET['s']) : '';

            	# how many polls per page?
            	$startlimit = 0;
            	if ($paged != 1) $startlimit = (($paged - 1) * $polls_per_page);
            	$limit = "LIMIT $startlimit, $polls_per_page";

            	# build the where clause for poll search term
            	$where = (empty($search)) ? '' : " WHERE poll_question LIKE '%".esc_sql($wpdb->esc_like($search))."%'";

            	# retrieve topic records
            	$polls = spdb_select('set', 'SELECT * FROM '.SPPOLLS."$where ORDER BY poll_id DESC $limit");
				$num_polls = spdb_count(SPPOLLS);
?>
				<form id="posts-filter" action="<?php echo SFADMINPLUGINS; ?>" method="get">
					<input type="hidden" name="page" value="simple-press/admin/panel-plugins/spa-plugins.php" />
					<input type="hidden" name="tab" value="plugin" />
					<input type="hidden" name="admin" value="sp_polls_admin_manage" />
					<input type="hidden" name="form" value="0" />
					<input type="hidden" name="polls_per_page" value="<?php echo $polls_per_page; ?>" />
					<ul class="subsubsub" style="padding-right:20px">
<?php
						echo '<li><a href="'.SFADMINPLUGINS.'&amp;tab=plugin&amp;admin=sp_polls_admin_manage&amp;form=0&amp;polls_per_page='.$polls_per_page.'">'.__('Show all polls', 'sp-polls').' ('.$num_polls.')</a></li>';
?>
					</ul>
					<p id="post-search">
						<input class="sfpostcontrol" style="width:250px;" type="text" id="post-search-input" name="s" value="<?php echo $search; ?>" />
						<input type="submit" value="<?php esc_attr_e(__('Search Poll Questions', 'sp-polls')); ?>" class="button" />
					</p>
					<div class="tablenav">
                        <?php esc_attr_e(__('Polls per page', 'sp-polls')); ?>:&nbsp;
    					<select name="polls_per_page" id="polls_per_page" style='font-weight:normal'>
        					<option <?php if ($polls_per_page == 5) echo 'selected="selected"'; ?> value="5">5</option>
        					<option <?php if ($polls_per_page == 10) echo 'selected="selected"'; ?> value="10">10</option>
        					<option <?php if ($polls_per_page == 20) echo 'selected="selected"'; ?> value="20">20</option>
        					<option <?php if ($polls_per_page == 25) echo 'selected="selected"'; ?> value="25">25</option>
        					<option <?php if ($polls_per_page == 50) echo 'selected="selected"'; ?> value="50">50</option>
        					<option <?php if ($polls_per_page == 100) echo 'selected="selected"'; ?> value="100">100</option>
    				    </select>
						<input type="submit" id="filter-submit" value="<?php esc_attr_e(__('Apply', 'sp-polls')); ?>" class="button-secondary" />
<?php
						$page_links = paginate_links(array(
							'total' => ceil($num_polls / $polls_per_page ),
							'current' => $paged,
							'base' => SFADMINPLUGINS.'&tab=plugin&admin=sp_polls_admin_manage&form=0&polls_per_page='.$polls_per_page.'&amp;%_%',
							'format' => 'paged=%#%',
							'add_args' => ''));

						if ($page_links) echo "<div class='tablenav-pages'>$page_links</div>";
?>
                        <br style="clear:both;" />
		   		    </div>
				</form>
<?php
                if ($polls) {
?>
                    <table class="widefat fixed spMobileTable800">
                        <thead>
                            <tr>
                                <th style='text-align:center'><?php echo __('Poll ID', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('Question', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('# Votes', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('# Voters', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('Start Date', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('Expiration Date', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('Hidden Results', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('Status', 'sp-polls'); ?></th>
                                <th style='text-align:center'><?php echo __('Manage', 'sp-polls'); ?></th>
                            </tr>
                        </thead>

                        <tbody>
<?php
                        $class = 'class="spMobileTableData alternate"';
                        foreach ($polls as $poll) {
?>
                        <tr id='sp-poll-<?php echo $poll->poll_id; ?>' <?php echo $class; ?>>
                            <td data-label='<?php echo __('Poll ID', 'sp-polls'); ?>' style='text-align:center'><?php echo $poll->poll_id; ?></td>
                            <td data-label='<?php echo __('Question', 'sp-polls'); ?>' ><?php echo $poll->poll_question; ?></td>
                            <td data-label='<?php echo __('Votes', 'sp-polls'); ?>' style='text-align:center'><?php echo $poll->poll_votes; ?></td>
                            <td data-label='<?php echo __('Voters', 'sp-polls'); ?>' style='text-align:center'><?php echo $poll->poll_voters; ?></td>
                            <td data-label='<?php echo __('Start', 'sp-polls'); ?>' style='text-align:center'><?php echo $poll->poll_date; ?></td>
                            <td data-label='<?php echo __('Exiration', 'sp-polls'); ?>' style='text-align:center'><?php echo $poll->poll_expiration; ?></td>
                            <td data-label='<?php echo __('Hide', 'sp-polls'); ?>' style='text-align:center'><?php echo $poll->hide_results; ?></td>
                            <td data-label='<?php echo __('Status', 'sp-polls'); ?>' style='text-align:center'><?php echo ($poll->poll_active) ? __('Active', 'sp-polls') : __('Inactive', 'sp-polls'); ?></td>
                            <td data-label='<?php echo __('Manage', 'sp-polls'); ?>' style='text-align:center'>
                                <?php
                                    $site = SFHOMEURL.'index.php?sp_ahah=polls-log&amp;sfnonce='.wp_create_nonce('forum-ahah')."&amp;action=poll-log&amp;pid=$poll->poll_id";
                                	$target = 'sp-poll-ajax';
                                	$gif = SFADMINIMAGES.'sp_WaitBox.gif';
                                ?>
                                <a href="javascript:void(null)">
        							<img src="<?php echo sp_find_icon(POLLSIMAGES, 'sp_PollsLogs.png'); ?>" title="<?php _e('Poll Log', 'sp-polls'); ?>" onclick="spjAdminTool('<?php echo $site; ?>', '<?php echo $target; ?>', '<?php echo $gif; ?>');" alt="" />&nbsp;&nbsp;
                                </a>
                                <?php
                                    $site = SFHOMEURL.'index.php?sp_ahah=polls-edit&amp;sfnonce='.wp_create_nonce('forum-ahah')."&amp;action=edit-poll&amp;pid=$poll->poll_id";
                                	$target = 'sp-poll-ajax';
                                	$gif = SFADMINIMAGES.'sp_WaitBox.gif';
                                ?>
                                <a href="javascript:void(null)">
        							<img src="<?php echo sp_find_icon(POLLSIMAGES, 'sp_PollsEdit.png'); ?>" title="<?php _e('Edit Poll', 'sp-polls'); ?>" onclick="spjAdminTool('<?php echo $site; ?>', '<?php echo $target; ?>', '<?php echo $gif; ?>');" alt="" />&nbsp;&nbsp;
                                </a>
                                <?php
                                    $msg = esc_js(__('Are you sure you want to delete this poll?'), 'sp-polls');
                                    $site = SFHOMEURL.'index.php?sp_ahah=polls-manage&amp;sfnonce='.wp_create_nonce('forum-ahah')."&amp;action=delete-poll&amp;pid=$poll->poll_id";
                                ?>
                                <a href="javascript:void(null)">
                                    <img src="<?php echo sp_find_icon(POLLSIMAGES, 'sp_PollsDelete.png'); ?>" title="<?php _e('Delete Poll', 'sp-polls'); ?>" onclick="javascript: if(confirm('<?php echo $msg; ?>')) {spjDelRow('<?php echo $site; ?>', 'sp-poll-<?php echo $poll->poll_id; ?>');}" alt="" />
                                </a>
                            </td>
                        </tr>
<?php
                		$class = (strpos($class, 'alternate') === false) ? ' class="spMobileTableData alternate"' : ' class="spMobileTableData"';
                    }
?>
                    </tbody>
                    </table>
<?php
                } else {
                    echo '<p>'.__('There are no polls in the database matching the criteria', 'sp-polls').'</p>';
                }
    		spa_paint_close_fieldset();
    	spa_paint_close_panel();
		spa_paint_close_container();
    spa_paint_close_tab();

	echo '<div class="sfform-panel-spacer"></div>';

    # hidden area for displaying poll log
	echo '<div id="sp-poll-ajax" class="sfinline-form"></div>';
}

?>