<?php
/*
Simple:Press
Polls Plugin Support Routines
$LastChangedDate: 2015-01-21 14:32:56 -0800 (Wed, 21 Jan 2015) $
$Rev: 12384 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_polls_do_create_forum() {
	spa_paint_checkbox(__('Enable polls on this forum', 'sp-polls'), 'forum_polls', 1);
}

function sp_polls_do_edit_forum($forum) {
	spa_paint_checkbox(__('Enable polls on this forum', 'sp-polls'), 'forum_polls', $forum->polls);
}

function sp_polls_do_head() {
	$css = sp_find_css(POLLSCSS, 'sp-polls.css', 'sp-polls.spcss');
    sp_plugin_enqueue_style('sp-polls', $css);

	$css = sp_find_css(POLLSCSS, 'jquery-ui.css');
    sp_plugin_enqueue_style('sp-polls-ui', $css);
}

function sp_polls_do_load_admin_js () {
    wp_enqueue_style('farbtastic');
    wp_enqueue_script('sp-polls-admin', POLLSSCRIPT.'sp-polls-admin.js', array('farbtastic'), false, false);
	$strings = array(
		'answer' 	=> esc_js(__('Answer', 'sp-polls')),
        'votes'     => esc_js(__('votes', 'sp-polls')),
        'verify'    => esc_js(__('Are you sure you want to delete this question? This cannot be undone. Save after deleting to update vote counts.','sp-polls')),
        'question'  => esc_js(__('Delete question','sp-polls')),
        'images'    => POLLSIMAGES,
	);
    wp_localize_script('sp-polls-admin', 'sp_polls_admin_vars', $strings);
}

function sp_polls_do_load_js($footer) {
    $script = (defined('SP_SCRIPTS_DEBUG') && SP_SCRIPTS_DEBUG) ? POLLSSCRIPT.'sp-polls-dev.js' : POLLSSCRIPT.'sp-polls.js';
	sp_plugin_enqueue_script('sp-polls', $script, array('jquery', 'jquery-form', 'jquery-ui-core', 'jquery-ui-widget', 'jquery-ui-datepicker'), false, $footer);
	$strings = array(
		'answer' 		=> esc_js(__('Answer', 'sp-polls')),
		'remove' 		=> esc_js(__('Remove Answer', 'sp-polls')),
        'toomany'       => esc_js(__('You have entered more than the max allowed votes', 'sp-polls')),
        'missing'       => esc_js(__('You did not enter a vote', 'sp-polls')),
	);
    sp_plugin_localize_script('sp-polls', 'sp_polls_vars', $strings);
}

function sp_polls_do_create_poll_form($out) {
	global $spGlobals, $spThisForum, $spThisTopic, $spThisPost, $spDevice;

	$polls = sp_get_option('polls');

    # bail if this is a post and can only add polls on new topics
    if (!empty($spThisPost) && $polls['topiccreate']) return $out;

    # make sure polls are enabled in this forum and user can create a poll
    $thisPage = (!empty($spThisPost)) ? $spThisTopic : $spThisForum;
    if (empty($thisPage->polls) || !$thisPage->polls || !sp_get_auth('create_poll', $thisPage->forum_id)) return $out;

    $toolTip = __('Add A Poll', 'sp-polls');
	$site = SFHOMEURL.'index.php?sp_ahah=polls-create&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;fid='.$thisPage->forum_id;

	if($spGlobals['display']['editor']['toolbar']) {
    	if (($spDevice=='mobile' && current_theme_supports('sp-theme-responsive'))) {
			# display mobile icon
			$out.= "<img src='".sp_find_icon(POLLSIMAGESMOB, "sp_PollToolbar.png")."' class='spIcon' id='spPollsButton' onclick='spjDialogAjax(this, \"$site\", \"$toolTip\", 600, 0, \"center\", \"sp-polls-ui\");' />";
		} else {
			$out.= "<input type='button' class='spSubmit spLeft' title='$toolTip' id='spPollsButton' value='".__('Poll', 'sp-polls')."' onclick='spjDialogAjax(this, \"$site\", \"$toolTip\", 600, 0, \"center\", \"sp-polls-ui\");' />";
		}
	} else {
		$out.= "<div class='spEditorTitle sp_poll_create'><a rel='nofollow' class='spButton' title='$toolTip' href='javascript:void(null)' onclick='spjDialogAjax(this, \"$site\", \"$toolTip\", 600, 0, \"center\", \"sp-polls-ui\");'>".__('Poll', 'sp-polls')."</a></div>";
	}

    return $out;
}

function sp_polls_do_PollsShortcode($atts) {
	global $spIsForum, $spThisForum, $spThisTopic, $spTopicView;

    $pollOutput = '';

    # we must have valid forum id
    if (empty($spThisForum) && empty($spThisTopic)) return '';

    extract(shortcode_atts(array('id' => ''), $atts));

    # make sure the shortcode appears in a forum post
    if (!$spIsForum || !isset($spTopicView) || !$spTopicView->inPostLoop) {
        $pollOutput.= '<div class="spPollError">'.__('A Simple Press Poll can only appear in a forum post', 'sp-polls').'</div>';
        return $pollOutput;
    }

    # verify we have a poll and grab the data
    if (empty($id)) return '<div class="spPollError">'.__('Poll ID missing', 'sp-polls').'</div>';

	$poll = spdb_table(SPPOLLS, "poll_id=$id", 'row');
    if (empty($poll)) return '<div class="spPollError">'.__('Poll ID invalid', 'sp-polls').'</div>';

    # should we show poll voting or results?
    $userVotes = sp_polls_user_voted($poll);
    $fid = (empty($spThisForum)) ? $spThisTopic->forum_id : $spThisForum->forum_id;
    if ($poll->poll_active) {
        # check if time to expire the poll
        if ($poll->poll_date > $poll->poll_expiration) {
            spdb_query('UPDATE '.SPPOLLS.' SET poll_active=0 WHERE poll_id='.$poll->poll_id);
            $poll->poll_active = 0;
            $pollOutput.= sp_polls_show_result($poll, true, $userVotes, $fid);
        } else {
            if ($userVotes || !sp_get_auth('vote_poll', $fid)) {
                $pollOutput.= sp_polls_show_result($poll, true, $userVotes, $fid);
            } else {
                $pollOutput.= sp_polls_show_vote($poll, true);
            }
        }
    } else {
        $pollOutput.= sp_polls_show_result($poll, true, $userVotes, $fid);
    }

    return $pollOutput;
}

function sp_polls_user_voted($poll) {
    $polls = sp_get_option('polls');

	switch ($polls['track']) {
		case 1: # none
			$userVotes = 0;
			break;

		case 2: # cookie
			$userVotes = sp_polls_check_cookie_vote($poll);
			break;

		case 3: # IP
			$userVotes = sp_polls_check_ip_vote($poll);
			break;

		case 4: # cookie and IP
			$checkCookie = sp_polls_check_cookie_vote($poll);
			if (!empty($checkCookie)) {
				$userVotes = $checkCookie;
			} else {
				$userVotes = sp_polls_check_ip_vote($poll);
			}
			break;

		case 5: # User ID
			$userVotes = sp_polls_check_user_vote($poll);
			break;
	}
    return $userVotes;
}

function sp_polls_check_cookie_vote($poll) {
    $userVotes = 0;
	if (!empty($_COOKIE["sp_voted_poll_$poll->poll_id"])) $userVotes = explode(',', $_COOKIE["sp_voted_poll_$poll->poll_id"]);
	return $userVotes;
}

function sp_polls_check_ip_vote($poll) {
    $polls_options = sp_get_option('polls');
	$userVotes = spdb_select('col', 'SELECT answer_id FROM '.SPPOLLSVOTERS." WHERE poll_id = $poll->poll_id AND user_ip = '".sp_polls_get_ip()."'");
    if (!$userVotes) $userVotes = 0;
	return $userVotes;
}

function sp_polls_check_user_vote($poll) {
	global $spThisUser;
	if ($spThisUser->guest) return 0;
	$userVotes = spdb_select('col', 'SELECT answer_id FROM '.SPPOLLSVOTERS." WHERE poll_id = $poll->poll_id AND user_id = $spThisUser->ID");
    if (!$userVotes) $userVotes = 0;
	return $userVotes;
}

function sp_polls_show_vote($poll, $container=false) {
	global $spThisForum, $spThisTopic;

    $fid = (empty($spThisForum)) ? $spThisTopic->forum_id : $spThisForum->forum_id;

    $out = '';

   # determine answer sort order from options
    $polls_options = sp_get_option('polls');
    $sort = ($polls_options['answersort'] == 1) ? ' ASC' : ' DESC';
    if ($polls_options['answercriteria'] == 1) {
        $order = 'answer_id'.$sort;
    } else if ($polls_options['answercriteria'] == 2) {
        $order = 'answer'.$sort;
    } else {
        $order = 'rand()';
    }

    # get all the possible answers for poll
    $answers = spdb_table(SPPOLLSANSWERS, "poll_id = $poll->poll_id", '', "$order");
    if (empty($answers)) return $out;

   	$img = SFCOMMONIMAGES.'working.gif';
?>
    <script>
        jQuery(document).ready(function() {
            var options = {
                target:         '#sp-poll-<?php echo $poll->poll_id; ?>',
                data:           { image: '<?php echo SFCOMMONIMAGES."working.gif"; ?>',
                                  maxAnswers: '<?php echo $poll->poll_maxanswers; ?>' },
                beforeSubmit:   spPollValidate,
            };
            jQuery("#sp-poll-form-<?php echo $poll->poll_id; ?>").ajaxForm(options);
        });
    </script>
<?php
    # display the poll
    if ($container) $out.= '<div id="sp-poll-'.$poll->poll_id.'" class="sp-poll">';
    $out.= '<p class="sp-poll-title">'.sp_filter_title_display($poll->poll_question).'</p>';
    $out.= '<div id="sp-poll-answers-'.$poll->poll_id.'" class="sp-poll-answers">';
    $url = SFHOMEURL.'index.php?sp_ahah=polls-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;action=vote-poll&ampfid='.$fid;
    $out.= '<form method="post" action="'.$url.'" id="sp-poll-form-'.$poll->poll_id.'" class="sp-poll-form">';
    $out.= '<input type="hidden" value="'.$poll->poll_id.'" name="poll-id" />';
    $out.= '<ul id="sp-poll-block-'.$poll->poll_id.'" class="sp-poll-block">';
    foreach ($answers as $answer) {
        $out.= '<li id="sp-poll-answer-'.$answer->answer_id.'" class="sp-poll-answer">';
        if ($poll->poll_maxanswers == 1) {
            $out.= '<input class="spControl" type="radio" value="'.$answer->answer_id.'" id="sfpollanswer-'.$answer->answer_id.'" name="sp-poll-answer" />';
            $out.= '<label class="sp-poll-label" for="sfpollanswer-'.$answer->answer_id.'">';
            $out.= sp_filter_title_display($answer->answer);
            $out.= "</label>\n";
        } else {
			$out.= "<input type='checkbox' class='spControl' name='sp-poll-answer[]' value='$answer->answer_id' id='sfpollanswer-$answer->answer_id' />\n";
 			$out.= "<label class='spLabel spCheckbox' for='sfpollanswer-$answer->answer_id'>";
            $out.= sp_filter_title_display($answer->answer);
            $out.= '</label>';
        }
        $out.= '</li>';
    }
    $out.= '</ul>';
    $out.= '<p class="sp-poll-submit"><input id="sfsave" class="spSubmit" type="submit" value="'.esc_attr(__('Vote', 'sp-polls')).'" name="votepoll"></p>';
    if (!$poll->hide_results) {
        $url = SFHOMEURL.'index.php?sp_ahah=polls-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;action=results-poll&amp;pid='.$poll->poll_id.'&amp;fid='.$fid;
        $out.= '<p class="sp-poll-show"><a class="sp-poll-show" rel="nofollow" href="javascript:void(null)" onclick="spjLoadTool(\''.$url.'\', \'sp-poll-'.$poll->poll_id.'\', \''.$img.'\')">'.esc_attr(__('View Poll Results', 'sp-polls')).'</a></p>';
    }
    $out.= '</form>';
    $out.= '</div>';
    if ($container) $out.= '</div>';
    return $out;
}

function sp_polls_show_result($poll, $container=false, $userVotes='', $fid) {
    $out = '';

	$userVotes = (array) $userVotes;
    $polls_options = sp_get_option('polls');

    if ($container) $out.= '<div id="sp-poll-'.$poll->poll_id.'" class="sp-poll">';

    if ($poll->hide_results && $poll->poll_active) {
        $out.= '<p class="sp-poll-title">'.sp_filter_title_display($poll->poll_question).'</p>';
        $out.= '<div id="sp-poll-results-'.$poll->poll_id.'" class="sp-poll-results">';
        $out.= '<ul id="sp-poll-block-'.$poll->poll_id.'" class="sp-poll-block">';
        $out.= '<li class="sp-poll-hide">'.$polls_options['hide-message'].'</li>';
        $out.= '</ul>';
        $out.= '</div>';
    } else {
        # determine results sort order from options
        $polls_options = sp_get_option('polls');
        $sort = ($polls_options['resultsort'] == 1) ? ' ASC' : ' DESC';
        if ($polls_options['resultcriteria'] == 1) {
            $order = 'answer_id'.$sort;
        } else if ($polls_options['resultcriteria'] == 2) {
            $order = 'answer'.$sort;
        } else if ($polls_options['resultcriteria'] == 3) {
            $order = 'answer_votes'.$sort;
        } else {
            $order = 'rand()';
        }

        # get all the possible answers for poll
        $answers = spdb_table(SPPOLLSANSWERS, "poll_id = $poll->poll_id", '', "$order");
        if (empty($answers)) return $out;

        # display the poll
        $out.= '<p class="sp-poll-title">'.sp_filter_title_display($poll->poll_question).'</p>';
        $out.= '<div id="sp-poll-results-'.$poll->poll_id.'" class="sp-poll-results">';
        $out.= '<ul id="sp-poll-block-'.$poll->poll_id.'" class="sp-poll-block">';
        foreach ($answers as $answer) {
            $user_class = (in_array($answer->answer_id, $userVotes)) ? 'class="sp-poll-result sp-user-voted"' : 'class="sp-poll-result"';
            $out.= '<li id="sp-poll-result-'.$answer->answer_id.'" '.$user_class.'>';
            $out.= sp_filter_title_display($answer->answer);
            $out.= '<span class="sp-poll-meta">';
            $percent = 0;
            $bar_width = 1;
            if ($poll->poll_voters > 0) {
                if ($answer->answer_votes > 0) {
                    $percent = round((($answer->answer_votes / $poll->poll_voters) * 100));
                    $percent = apply_filters('sph_polls_vote_percent', $percent, $poll, $answer);
                    $bar_width = $percent;
                }
            }
            $vote = ($answer->answer_votes == 0 || $answer->answer_votes > 1) ? __('votes', 'sp-polls') : __('vote', 'sp-polls');
            $out.= "($percent% : $answer->answer_votes $vote)";
            $out.= '</span>';
            $out.= '<div class="sp-poll-bar" style="width: '.$bar_width.'%; background-color: #'.$polls_options['bar-background'].'; border: 1px solid #'.$polls_options['bar-border'].'; height: '.$polls_options['bar-height'].'px;">';
            $out.= '</div>';
            $out.= '</li>';
        }
        $out.= '</ul>';

        $out.= '<div class="sp-poll-count">';
        $out.= __('Total Voters', 'sp-polls').': '.$poll->poll_voters;
        $out.= '</div>';

        # should we show poll voting or results?
        if ($poll->poll_active && empty($userVotes[0])) {
            if (sp_get_auth('vote_poll', $fid)) {
               	$img = SFCOMMONIMAGES.'working.gif';
                $url = SFHOMEURL.'index.php?sp_ahah=polls-manage&amp;sfnonce='.wp_create_nonce('forum-ahah').'&amp;action=show-poll&amp;pid='.$poll->poll_id;
                $out.= '<p class="sp-poll-show"><a class="sp-poll-show" rel="nofollow" href="javascript:void(null)" onclick="spjLoadTool(\''.$url.'\', \'sp-poll-'.$poll->poll_id.'\', \''.$img.'\')">'.esc_attr(__('Vote in Poll', 'sp-polls')).'</a></p>';
            }
        }
        $out.= '</div>';
    }

    if ($container) $out.= '</div>';
    return $out;
}

function sp_polls_get_ip() {
	if (empty($_SERVER["HTTP_X_FORWARDED_FOR"])) {
		$ip = $_SERVER["REMOTE_ADDR"];
	} else {
		$ip = $_SERVER["HTTP_X_FORWARDED_FOR"];
	}
	if (strpos($ip, ',') !== false) {
		$ip = explode(',', $ip);
		$ip = $ip[0];
	}
    $ip = sp_esc_str($ip);
	return $ip;
}

function sp_polls_do_admin_save_poll() {
	check_admin_referer('forum-adminform_userplugin', 'forum-adminform_userplugin');

    if (!sp_current_user_can('SPF Manage Polls') && !empty($poll_id)) return;

    if (empty($_POST['sp-poll-answer']) || empty($_POST['sp-poll-answer-count'])) return __('A poll must have answers', 'sp-polls');

    $pid = $_POST['sp-poll-id'];

    # save the questions
    $totalVotes = 0;
    foreach ($_POST['sp-poll-answer'] as $answer_id => $answer) {
        $answer = sp_esc_str($answer);
        if (!empty($answer)) {
            $votes = sp_esc_int($_POST['sp-poll-answer-votes'][$answer_id]);
            if ($votes < 0) $votes = 0;
            $totalVotes = $totalVotes + $votes;

            # is it edit of existing answer or a new one?
            if ($answer_id < 0) {
                spdb_query('INSERT INTO '.SPPOLLSANSWERS." (poll_id, answer, answer_votes) VALUES ($pid, '$answer', $votes)"); # new answer
            } else {
                spdb_query('UPDATE '.SPPOLLSANSWERS." SET
                            answer='$answer',
                            answer_votes=$votes
                            WHERE poll_id = $pid AND answer_id = $answer_id");
            }
        }
    }

    # check data
    $question = sp_filter_title_save($_POST['sp-poll-question']);
    if (empty($question)) return __('A poll must have a question', 'sp-polls');

    $user = sp_esc_int($_POST['sp-poll-user']);
    if (empty($user)) return __('A poll must have a user as creator', 'sp-polls');

    $max = sp_esc_int($_POST['sp-poll-max']);
    if ($max < 1) $max = 1;
    $date = sp_esc_str($_POST['sp-poll-date']);
    $expire = sp_esc_str($_POST['sp-poll-expiration']);
    $active = isset($_POST['sp-poll-active']) ? 1 : 0;
    $voters = sp_esc_int($_POST['sp-poll-voters']);
    if ($voters < 0) $voters = 0;

    # are we hiding results?
    $polls = sp_get_option('polls');
    $hide = ($polls['hide-results'] && !empty($_POST['sp-poll-hide'])) ? 1 : 0;

    # save poll data
    spdb_query('UPDATE '.SPPOLLS." SET
                poll_question='$question',
                poll_maxanswers=$max,
                poll_date='$date',
                poll_expiration='$expire',
                user_id=$user,
                poll_active=$active,
                poll_votes=$totalVotes,
                poll_voters=$voters,
                hide_results=$hide
                WHERE poll_id = $pid");

    return __('Poll updated', 'sp-polls');
}

function sp_poll_do_admin_cap_list($user) {
	$manage_polls = ($user->has_cap('SPF Manage Polls')) ? 1 : 0;
	echo '<li>';
	spa_render_caps_checkbox(__('Manage Polls', 'sp-polls'), "manage-polls[$user->ID]", $manage_polls, $user->ID);
	echo "<input type='hidden' name='old-polls[$user->ID]' value='$manage_polls' />";
	echo '</li>';
}

function sp_poll_do_admin_cap_form($user) {
	echo '<li>';
	spa_render_caps_checkbox(__('Manage Polls', 'sp-polls'), 'add-polls', 0);
	echo '</li>';
}

function sp_poll_do_admin_caps_update($still_admin, $remove_admin, $user) {
    $manage_polls = (isset($_POST['manage-polls'])) ? $_POST['manage-polls'] : '';
    $old_polls = (isset($_POST['old-polls'])) ? $_POST['old-polls'] : '';

    # was this admin removed?
    if (isset($remove_admin[$user->ID])) $manage_polls = '';

	if (isset($manage_polls[$user->ID])) {
		$user->add_cap('SPF Manage Polls');
	} else {
		$user->remove_cap('SPF Manage Polls');
	}
	$still_admin = $still_admin || isset($manage_polls[$user->ID]);
	return $still_admin;
}

function sp_poll_do_admin_caps_new($newadmin, $user) {
    $polls = (isset($_POST['add-polls'])) ? $_POST['add-polls'] : '';
	if ($polls == 'on') $user->add_cap('SPF Manage Polls');
	$newadmin = $newadmin || $polls == 'on';
	return $newadmin;
}

?>