<?php
/*
Simple:Press
Polls plugin uninstall routine
$LastChangedDate: 2014-08-23 17:37:40 -0700 (Sat, 23 Aug 2014) $
$Rev: 11898 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

# this uninstall function is for the report post plugin uninstall only
function sp_polls_do_uninstall() {
	# remove the auth
	if (!empty($spGlobals['auths_map']['create_poll'])) sp_delete_auth('create_poll');
	if (!empty($spGlobals['auths_map']['vote_poll'])) sp_delete_auth('vote_poll');

	# remove any admin capabilities
	$admins = spdb_table(SFMEMBERS, "admin=1");
	foreach ($admins as $admin) {
		$user = new WP_User($admin->user_id);
		$user->remove_cap('SPF Manage Polls');
	}

	spdb_query('ALTER TABLE '.SFFORUMS.' DROP polls');
	spdb_query('ALTER TABLE '.SFPOSTS.' DROP poll');

    # remove our auths
    sp_delete_auth('create_poll');
    sp_delete_auth('vote_poll');

    # delete our option table
    sp_delete_option('polls');

    # remove our tables
	spdb_query('DROP TABLE IF EXISTS '.SPPOLLS);
	spdb_query('DROP TABLE IF EXISTS '.SPPOLLSANSWERS);
	spdb_query('DROP TABLE IF EXISTS '.SPPOLLSVOTERS);
}

function sp_polls_do_deactivate() {
    sp_deactivate_auth('create_poll');
    sp_deactivate_auth('vote_poll');
}

function sp_polls_do_sp_deactivate() {
}

function sp_polls_do_sp_uninstall() {
	# remove any admin capabilities
	$admins = spdb_table(SFMEMBERS, "admin=1");
	foreach ($admins as $admin) {
		$user = new WP_User($admin->user_id);
		$user->remove_cap('SPF Manage Polls');
	}

    # make sure sp uninstall initiated
	if (sp_get_option('sfuninstall')) {
		spdb_query('DROP TABLE IF EXISTS '.SPPOLLS);
		spdb_query('DROP TABLE IF EXISTS '.SPPOLLSANSWERS);
    	spdb_query('DROP TABLE IF EXISTS '.SPPOLLSVOTERS);
    }
}

function sp_polls_uninstall_option_links($actionlink, $plugin) {
	if ($plugin == 'polls/sp-polls-plugin.php') {
        $url = SFADMINPLUGINS.'&amp;action=uninstall&amp;plugin='.$plugin.'&amp;sfnonce='.wp_create_nonce('forum-adminform_plugins');
        $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Uninstall this plugin', 'sp-polls')."'>".__('Uninstall', 'sp-polls').'</a>';
        $url = SFADMINPLUGINS.'&amp;tab=plugin&amp;admin=sp_polls_admin_options&amp;save=sp_polls_admin_options_save&amp;form=1';
        $actionlink.= "&nbsp;&nbsp;<a href='$url' title='".__('Options', 'sp-polls')."'>".__('Options', 'sp-polls').'</a>';
    }
	return $actionlink;
}

?>