<?php
/*
Simple:Press
Polls plugin install/upgrade routine
$LastChangedDate: 2014-06-07 14:32:19 -0700 (Sat, 07 Jun 2014) $
$Rev: 11528 $
*/

if (preg_match('#'.basename(__FILE__).'#', $_SERVER['PHP_SELF'])) die('Access denied - you cannot directly call this file');

function sp_polls_do_upgrade_check() {
    if (!sp_is_plugin_active('polls/sp-polls-plugin.php')) return;

    $polls = sp_get_option('polls');

    $db = $polls['dbversion'];
    if (empty($db)) $db = 0;

    # quick bail check
    if ($db == SPPOLLSDBVERSION ) return;

    # apply upgrades as needed

    # db version upgrades
    if ($db < 1) {
	   spdb_query('UPDATE '.SFAUTHS." SET auth_cat=3 WHERE auth_name='create_poll'");
	   spdb_query('UPDATE '.SFAUTHS." SET auth_cat=1 WHERE auth_name='vote_poll'");
    }

    if ($db < 2) {
    	sp_delete_auth('create_poll');
    	sp_delete_auth('vote_poll');
    	sp_add_auth('create_poll', __('Can create a forum poll within a post', 'sp-polls'), 1, 0, 0, 0, 3);
    	sp_add_auth('vote_poll', __('Can vote in a forum poll within a post', 'sp-polls'), 1, 0, 0, 0, 1);
    }

    if ($db < 3) {
        spdb_query('ALTER TABLE '.SPPOLLS.' ADD (hide_results tinyint(1) default 0)');
    	$polls['hide-results'] = false;
        $polls['hide-message'] = __('Thank you for voting. Poll results will be available when the poll has closed.', 'sp-polls');
    }

    if ($db < 4) {
        # give new manage polls cap to any admin with manage options cap since they already can manage pm
    	$admins = spdb_table(SFMEMBERS, 'admin = 1');
    	if ($admins) {
    	   foreach ($admins as $admin) {
                $user = new WP_User($admin->user_id);
                if ($user->has_cap('SPF Manage Components')) {
                    $user->add_cap('SPF Manage Polls');
                }
            }
        }
    }

    # save data
    $polls['dbversion'] = SPPOLLSDBVERSION;
    sp_update_option('polls', $polls);
}

?>